<?php

/**
 * Simple wrapper for JNotify JQuery plugin. please read the license below.
 * Coder: Ferly Sopan Atmaja (ibiz4)
 */

/*
 * jNotify jQuery Plug-in
 *
 * Copyright 2010 Giva, Inc. (http://www.givainc.com/labs/) 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * 	http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Date: 2010-09-30
 * Rev:  1.1.00

 
  // define core settings
    type: ""                                  // if a type is specified, then an additional class of classNotification 
                                              // + type is created for each notification
  , delay: 2000                               // the default time to show each notification (in milliseconds)
  , sticky: false                             // determines if the message should be considered "sticky" (user 
                                              // must manually close notification)
  , closeLabel: "&times;"                     // the HTML to use for the "Close" link
  , showClose: true                           // determines if the "Close" link should be shown if notification is also sticky
  , fadeSpeed: 1000                           // the speed to fade messages out (in milliseconds)
  , slideSpeed: 250                           // the speed used to slide messages out (in milliseconds)
  
  // define the class statements
  , classContainer: "jnotify-container"       // className to use for the outer most container--this is where all the 
                                              // notifications appear
  , classNotification: "jnotify-notification" // className of the individual notification containers
  , classBackground: "jnotify-background"     // className of the background layer for each notification container
  , classClose: "jnotify-close"               // className to use for the "Close" link
  , classMessage: "jnotify-message"           // className to use for the actual notification text container--this is 
                                              // where the message is actually written

  // event handlers
  , init: null                                // callback that occurs when the main jnotify container is created
  , create: null                              // callback that occurs when when the note is created (occurs just before 
                                              // appearing in DOM)
  , beforeRemove: null                        // callback that occurs when before the notification starts to fade away
  , remove: null                              // callback that occurs when notification is removed
  , transition: null                          // allows you to overwrite how the transitions between messages are handled
                                              // receives the following arguments:
                                              //   container - jQuery object containing the notification
                                              //   message   - jQuery object of the actual message
                                              //   count     - the number of items left in queue
                                              //   callback  - a function you must execute once your transition has executed
                                              //   options   - the options used for this jnotify instance
											  
Configuration can be like this:

<?php
$this->widget('ext.JNotifier.JNotifier', array(
	'initial'=>array(	// array for execute notification at time or set true (boolean) provide initialization for another execute way
		'style'=>'alternative', // string, 1. alternative, 2. else or not set = default style
		'type'=>'',				// string, 1. error, 2. warning 3 else or not set = notification
		'text'=>'Hello World!',	// notification text
		//'delay'=>200, 		// integer, if not set = notification will sticked automatically
		'registerCore'=>true,	// false if already register jquery core in same page
	),
	
	//  External trigger only created while 'initial'=>true  
	// 'extTrigger'=>CHtml::link('Trigger','#', array('onclick'=>"$.jnotify('This is a notification.', true)")), 
	
	//	other core settings	
	// 'closeLabel'=>"&times;",	// string HTML entities
	// 'showClose'=>true,
	// 'fadeSpeed'=>1000,
	// 'slideSpeed'=>250,
	
	//	events setting	
	// 'init'=>null,		// "function (){ alert('notification has init'd');}",
	// 'create'=>null,		//"function (){ alert('will create notification');}",
	// 'beforeRemove'=>null, //"function (){ alert('will remove notification!');}"
	// 'remove'=>null,		//"function (){ alert('notification removed!');}"
	// 'transition'=>null
)); ?>											  
*/

class JNotifier extends CWidget {

	private $baseUrl;
	private $clientScript;
	
	private $style;
	private $type;
	private $text;
	private $delay;
	private $sticky;
	
	public $registerCore;
	
	public $initial		=	array();
	public $closeLabel;
	public $showClose;
	public $fadeSpeed;
	public $slideSpeed;

	public $init;
	public $create;
	public $beforeRemove;
	public $remove;
	public $transition;
	
	public $extTrigger;

	private function buildSetup()	{	// Nasty code just for flexibility purpose only

			$this->style		=	($this->initial['style']=="alternative")?"alternative":"default";
			$this->type			=	($this->initial['type']=="warning" || $this->initial['type']=="error")?$this->initial['type']:"";
			$this->text			=	is_string($this->initial['text'])?$this->initial['text']:"";
			$this->delay		=	is_int($this->initial['delay'])?$this->initial['delay']:2000;
			$this->sticky		=	is_int($this->initial['delay'])?"false":"true";	// set delay = not sticky, not diset delay = sticky, 	
			
			$this->closeLabel	=	is_string($this->closeLabel)?$this->closeLabel:"&times;";
			$this->showClose	=	($this->showClose === false)?"false":"true";
			$this->fadeSpeed	=	is_int($this->fadeSpeed)?$this->fadeSpeed:1000;
			$this->slideSpeed	=	is_int($this->slideSpeed)?$this->slideSpeed:250;

			$this->init			=	is_string($this->init)?$this->init:"null";
			$this->create		=	is_string($this->create)?$this->create:"null";
			$this->beforeRemove	=	is_string($this->beforeRemove)?$this->beforeRemove:"null";
			$this->remove		=	is_string($this->remove)?$this->remove:"null";
			$this->transition	=	is_string($this->transition)?$this->transition:"null";
	}
	
	private function registerClientScripts() {

		$dir = dirname(__FILE__);
		$this->baseUrl =Yii::app()->getAssetManager()->publish($dir);
		
		if ($this->baseUrl === '')
			throw new CException(Yii::t('JNotifier', 'baseUrl must be set.'));

		$this->clientScript	=	Yii::app()->getClientScript();
		if($this->initial[registerCore] || ($this->initial === true))	// Wanna register teh core?
			$this->clientScript->registerCoreScript('jquery'); 
			
		// Jnotify script
		$this->clientScript->registerScriptFile($this->baseUrl.'/jquery.jnotify.min.js');
		$selector	=	($this->initial[style] == "alternative")?"-alt":".min";	// style css selection
		$this->clientScript->registerCssFile($this->baseUrl.'/jquery.jnotify'.$selector.'.css', 'all');
	}

	private function createTriggerCode() {

			$triggerCode= <<<END
			( function($) {
				$(document).ready(function() {
					$.jnotify.setup({
						type: "{$this->type}",
						delay: {$this->delay},
						sticky: {$this->sticky},
						closeLabel: "{$this->closeLabel}",
						showClose: {$this->showClose},
						fadeSpeed: {$this->fadeSpeed},
						slideSpeed: {$this->slideSpeed},
						init: {$this->init},
						create: {$this->create},
						beforeRemove: {$this->beforeRemove},
						remove: {$this->remove},
						transition: "{$this->transition}"
					});
					$.jnotify("$this->text"); 
				});
			} ) ( jQuery );
END;

		return $triggerCode;
	}

	/**
	 * Run the widget
	 */
	public function run() {

		if(!isset($this->initial))
			throw new CException(Yii::t('JNotifier', 'You must set the "initial" property so you can play with this extension.'));
		else	{
			if($this->initial === true)
				$this->registerClientScripts();
			elseif(is_array($this->initial) && !empty($this->initial))	{
					$this->buildSetup();
					$js = $this->createTriggerCode();
					$this->registerClientScripts();
					$this->clientScript->registerScript('jnotifier_init', $js, CClientScript::POS_END);
			}
		}

		parent::run();
		
		if(is_string($this->extTrigger) && ($this->initial === true))
			echo CHtml::decode($this->extTrigger);
	}
	
	/* public function setregisterCore($registerCore)
    {
        $this->registerCore = $registerCore;
    } */

}